#include <bits/stdc++.h>
using namespace std;

int main() {
    #define ll long long

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    //cout.tie(NULL);
    
    int n,q,type,p,l,r,len,sum;
    cin >> n >> q;
    int a[n],s[n];
    cin >> a[0];
    s[0] = a[0];
    for(int i = 1; i < n; i++)
    {
        cin >> a[i];
        s[i] += a[i];
    }

    for(int Q = 0; Q < q; Q++)
    {
        cin >> type;
        if(type == 1)
        {
            cin >> p;
            a[p-1] = 0 - a[p-1];

            for(int i = p; i < n; i++)
            {
                s[i]++;
            }
        }
        else
        {
            //TYPE 2
            cin >> l >> r;
            len = r-l+1;

            for(int i = l-1; i < r; i++)
            {
                if(a[i] == -1)
                {
                    l++;
                    len--;
                }
                else
                {
                    break;
                }
            }
            for(int i = r-1; i >= l-1; i--)
            {
                if(a[i] == -1)
                {
                    r--;
                    len--;
                }
                else
                {
                    break;
                }
            }

            sum = a[l-1];

            for(int i = l; i < r; i++)
            {
                sum += a[i];
                if(sum < 0)
                {
                    len--;
                }
                if(s[r-1] - s[i-1] < 0)
                {
                    len--;
                    i++;
                }
            }

            cout << len << "\n";
        }
    }
}